module.exports = /******/
function(modules) {
    /******/
    /******/
    // The require function
    /******/
    function __webpack_require__(moduleId) {
        /******/
        /******/
        // Check if module is in cache
        /******/
        if (installedModules[moduleId]) /******/
        return installedModules[moduleId].exports;
        /******/
        /******/
        // Create a new module (and put it into the cache)
        /******/
        var module = installedModules[moduleId] = {
            /******/
            exports: {},
            /******/
            id: moduleId,
            /******/
            loaded: !1
        };
        /******/
        /******/
        // Return the exports of the module
        /******/
        /******/
        /******/
        // Execute the module function
        /******/
        /******/
        /******/
        // Flag the module as loaded
        /******/
        return modules[moduleId].call(module.exports, module, module.exports, __webpack_require__), 
        module.loaded = !0, module.exports;
    }
    // webpackBootstrap
    /******/
    // The module cache
    /******/
    var installedModules = {};
    /******/
    /******/
    // Load entry module and return exports
    /******/
    /******/
    /******/
    /******/
    // expose the modules object (__webpack_modules__)
    /******/
    /******/
    /******/
    // expose the module cache
    /******/
    /******/
    /******/
    // __webpack_public_path__
    /******/
    return __webpack_require__.m = modules, __webpack_require__.c = installedModules, 
    __webpack_require__.p = "", __webpack_require__(0);
}([ /* 0 */
/***/
function(module, exports, __webpack_require__) {
    "use strict";
    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }
    function canChangeToList(pm, listsTypes) {
        return listsTypes.some(function(type) {
            return _akEditorProsemirror.commands.wrapInList(pm.schema.nodes[type])(pm, !1);
        });
    }
    function isNodeListable(proseMirrorInstance, node) {
        var nodeType = node.type.name, nodeSpecOrderedMap = proseMirrorInstance.schema.nodeSpec;
        return nodeSpecOrderedMap.get(nodeType).group.split(" ").indexOf(DISABLED_GROUP) === -1;
    }
    function isShallowObjectEqual(oldObject, newObject) {
        return (0, _stringify2.default)(oldObject) === (0, _stringify2.default)(newObject);
    }
    function isListNode(node) {
        return (0, _akEditorSchema.isBulletListNode)(node) || (0, _akEditorSchema.isOrderedListNode)(node);
    }
    Object.defineProperty(exports, "__esModule", {
        value: !0
    });
    var _assign = __webpack_require__(1), _assign2 = _interopRequireDefault(_assign), _classCallCheck2 = __webpack_require__(2), _classCallCheck3 = _interopRequireDefault(_classCallCheck2), _createClass2 = __webpack_require__(3), _createClass3 = _interopRequireDefault(_createClass2), _stringify = __webpack_require__(4), _stringify2 = _interopRequireDefault(_stringify), _akEditorProsemirror = __webpack_require__(5), _akEditorSchema = __webpack_require__(6), DISABLED_GROUP = "unlistable", DEFAULT_STATE = {
        active: !1,
        enabled: !0,
        type: null
    };
    exports.default = new _akEditorProsemirror.Plugin(function() {
        function ListsPlugin(pm) {
            var _this = this;
            (0, _classCallCheck3.default)(this, ListsPlugin), this.pm = pm, this.state = DEFAULT_STATE, 
            this.changeHandlers = [], this.listTypes = [ "bullet_list", "ordered_list" ];
            var listItem = pm.schema.nodes.list_item;
            pm.addKeymap(new _akEditorProsemirror.Keymap({
                Enter: function() {
                    return _akEditorProsemirror.commands.splitListItem(listItem)(pm);
                }
            })), this.updater = pm.updateScheduler([ pm.on.selectionChange, pm.on.change ], function() {
                return _this.update();
            });
        }
        // When typescript spread operator is implemented we can remove this boiler
        // plate in favour of spread assignment
        return (0, _createClass3.default)(ListsPlugin, [ {
            key: "getState",
            value: function() {
                return (0, _assign2.default)({}, this.state);
            }
        }, {
            key: "setState",
            value: function() {
                for (var _len = arguments.length, newState = Array(_len), _key = 0; _key < _len; _key++) newState[_key] = arguments[_key];
                return this.state = _assign2.default.apply(Object, [ {}, DEFAULT_STATE ].concat(newState)), 
                this.state;
            }
        }, {
            key: "update",
            value: function() {
                var _this2 = this, pm = this.pm, _pm$selection = pm.selection, $head = _pm$selection.$head, $from = _pm$selection.$from, $to = _pm$selection.$to, oldState = this.getState(), $resolvedPos = $head || $to, activeNode = pm.doc.nodeAt($resolvedPos.pos - 1), rootNode = $from.node(1), isListable = activeNode ? isNodeListable(pm, activeNode) : oldState.enabled, canChange = canChangeToList(pm, this.listTypes);
                isListNode(rootNode) && activeNode ? this.setState({
                    active: !0,
                    type: rootNode.type.name,
                    enabled: !0
                }) : isListable && canChange ? this.setState() : this.setState({
                    enabled: !1
                }), isShallowObjectEqual(oldState, this.state) || this.changeHandlers.every(function(cb) {
                    return cb(_this2.getState());
                });
            }
        }, {
            key: "blockNodesBetween",
            value: function($from, $to) {
                for (var current = this.pm.doc.resolve($from.start(1)), nodes = Array(); current.pos <= $to.start(1); ) {
                    nodes.push(current.node(1));
                    var next = this.pm.doc.resolve(current.after(1));
                    if (next.start(1) > this.pm.doc.content.size) break;
                    current = this.pm.doc.resolve(next.start(1));
                }
                return nodes;
            }
        }, {
            key: "isRangeOfType",
            value: function($from, $to, type) {
                return 0 === this.blockNodesBetween($from, $to).filter(function(node) {
                    return node.type.name !== type;
                }).length;
            }
        }, {
            key: "rangeContainsList",
            value: function($from, $to) {
                return this.blockNodesBetween($from, $to).some(isListNode);
            }
        }, {
            key: "liftSelection",
            value: function($from, $to) {
                var tr = this.pm.tr, startPos = $from.start($from.depth), endPos = $to.end($to.depth);
                // We want to select the entire node
                return tr.doc.nodesBetween(startPos, endPos, function(node, pos) {
                    if (node.isText || node.isTextblock && !node.textContent) {
                        var res = tr.doc.resolve(tr.map(pos)), sel = new _akEditorProsemirror.NodeSelection(res), range = sel.$from.blockRange(sel.$to), target = (0, 
                        _akEditorProsemirror.liftTarget)(range);
                        tr.lift(range, target);
                    }
                }), startPos = tr.map(startPos), endPos = tr.doc.resolve(tr.map(endPos)).end(1), 
                tr.setSelection(new _akEditorProsemirror.TextSelection(tr.doc.resolve(startPos), tr.doc.resolve(endPos))), 
                tr;
            }
        }, {
            key: "shouldJoinUp",
            value: function(selection, doc, type) {
                var res = doc.resolve(selection.$from.before(1));
                return res.nodeBefore && res.nodeBefore.type.name === type;
            }
        }, {
            key: "shouldJoinDown",
            value: function(selection, doc, type) {
                var res = doc.resolve(selection.$to.after(1));
                return res.nodeAfter && res.nodeAfter.type.name === type;
            }
        }, {
            key: "adjustSelection",
            value: function(selection) {
                var $from = selection.$from, $to = selection.$to, isSameLine = $from.pos === $to.pos;
                isSameLine && ($from = this.pm.doc.resolve($from.start($from.depth)), $to = this.pm.doc.resolve($from.end($from.depth)));
                var startPos = $from.pos, endPos = $to.pos;
                if (isSameLine && startPos === this.pm.doc.content.size - 1) return selection;
                if ($from.nodeBefore) if (isSameLine) {
                    if (!$from.nodeAfter) {
                        startPos--;
                        for (var _node = this.pm.doc.nodeAt(startPos); !_node || _node && !_node.isText; ) startPos--, 
                        _node = this.pm.doc.nodeAt(startPos);
                    }
                } else {
                    startPos++;
                    for (var node = this.pm.doc.nodeAt(startPos); !node || node && !node.isText; ) startPos++, 
                    node = this.pm.doc.nodeAt(startPos);
                }
                if ($to.parentOffset) endPos--; else if ($to.nodeAfter && (!$from.nodeAfter || !isSameLine)) {
                    endPos--;
                    for (var _node2 = this.pm.doc.nodeAt(endPos); _node2 && !_node2.isText; ) endPos--, 
                    _node2 = this.pm.doc.nodeAt(endPos);
                }
                if (!$from.parent || !$from.parent.isTextblock || $from.parent.textContent) for (var _node3 = this.pm.doc.nodeAt(startPos); !_node3 || _node3 && !_node3.isText; ) startPos++, 
                _node3 = this.pm.doc.nodeAt(startPos);
                if (!$to.parent || !$to.parent.isTextblock || $to.parent.textContent) for (var _node4 = this.pm.doc.nodeAt(endPos); !_node4 || _node4 && !_node4.isText; ) endPos--, 
                _node4 = this.pm.doc.nodeAt(endPos);
                return endPos === startPos ? new _akEditorProsemirror.TextSelection(this.pm.doc.resolve(startPos)) : new _akEditorProsemirror.TextSelection(this.pm.doc.resolve(startPos), this.pm.doc.resolve(endPos));
            }
        }, {
            key: "resetSelection",
            value: function() {
                var newSelection = new _akEditorProsemirror.TextSelection(this.pm.selection.$to);
                this.pm.setSelection(newSelection);
            }
        }, {
            key: "toggleList",
            value: function(type) {
                var pm = this.pm, _pm$selection2 = pm.selection, $from = _pm$selection2.$from, $to = _pm$selection2.$to, adjustedSelection = this.adjustSelection(pm.selection);
                $from === $to && (pm.setSelection(adjustedSelection), $from = pm.selection.$from, 
                $to = pm.selection.$to);
                var rootNode = $from.node(1), isList = this.listTypes.indexOf(rootNode.type.name) !== -1, isRangeOfType = this.isRangeOfType(adjustedSelection.$from, adjustedSelection.$to, type), shouldUntoggle = isRangeOfType, rangeContainsList = this.rangeContainsList($from, $to), shouldConvertToType = !isRangeOfType && (isList || rangeContainsList);
                if (shouldUntoggle) return $from.parent === $to.parent ? _akEditorProsemirror.commands.lift(pm, !0) : (this.liftSelection(adjustedSelection.$from, adjustedSelection.$to).applyAndScroll(), 
                this.resetSelection(), !0);
                if (shouldConvertToType) {
                    var tr = this.liftSelection(adjustedSelection.$from, adjustedSelection.$to).applyAndScroll();
                    return pm.setSelection(tr.selection), _akEditorProsemirror.commands.wrapInList(tr.pm.schema.nodes[type])(tr.pm), 
                    this.shouldJoinUp(pm.selection, pm.doc, type) && _akEditorProsemirror.commands.joinUp(pm, !0), 
                    this.shouldJoinDown(pm.selection, pm.doc, type) && _akEditorProsemirror.commands.joinDown(pm, !0), 
                    this.resetSelection(), !0;
                }
                /*
	                     * joinDown expects the selection to be from the end of our last node to
	                     * the beginning of the next. So we need to adjust our selection a bit.
	                     * */
                return pm.setSelection(this.adjustSelection(pm.selection)), _akEditorProsemirror.commands.wrapInList(pm.schema.nodes[type])(pm), 
                this.shouldJoinUp(pm.selection, pm.doc, type) && _akEditorProsemirror.commands.joinUp(pm, !0), 
                this.shouldJoinDown(pm.selection, pm.doc, type) && (pm.setSelection(new _akEditorProsemirror.TextSelection(pm.selection.$to, pm.doc.resolve(pm.selection.$to.after(1)))), 
                _akEditorProsemirror.commands.joinDown(pm, !0)), this.resetSelection(), !0;
            }
        }, {
            key: "subscribe",
            value: function(cb) {
                this.changeHandlers.push(cb), cb(this.getState());
            }
        } ]), ListsPlugin;
    }());
}, /* 1 */
/***/
function(module, exports) {
    module.exports = require("babel-runtime/core-js/object/assign");
}, /* 2 */
/***/
function(module, exports) {
    module.exports = require("babel-runtime/helpers/classCallCheck");
}, /* 3 */
/***/
function(module, exports) {
    module.exports = require("babel-runtime/helpers/createClass");
}, /* 4 */
/***/
function(module, exports) {
    module.exports = require("babel-runtime/core-js/json/stringify");
}, /* 5 */
/***/
function(module, exports) {
    module.exports = require("ak-editor-prosemirror");
}, /* 6 */
/***/
function(module, exports) {
    module.exports = require("ak-editor-schema");
} ]);